<?php
function reflect_css_rule($selector, $option, $property){
	$data = reflect_mood($option);
	$output = '';
	
	if($data != ''){
		if($property == 'background-image'){
			$output = $selector.'{'.$property.':url('.$data.');}';
		}elseif($property == 'placeholder-color'){
			$output = $selector.'::-webkit-input-placeholder{'.$property.':'.$data.';}';
			$output .= $selector.'::-moz-placeholder{'.$property.':'.$data.';}';
			$output .= $selector.':-ms-input-placeholder{'.$property.':'.$data.';}';
			$output .= $selector.':-moz-placeholder{'.$property.':'.$data.';}';
		}else{
			$output = $selector.'{'.$property.':'.$data.';}';
		}
	}
	
	return $output;
}

function reflect_custom_css(){
	$css = '';
	
	/*
		Typography
	===========================================================*/
	/* Font Family*/
	$css .= 'body{ font-family:'.reflect_fonts_style(2).'; }';
	$css .= '.primary_nav a{ font-family:'. reflect_fonts_style(1).'; }';
	$css .= 'h1{ font-family:'. reflect_fonts_style(0).'; }';
	$css .= 'h2{ font-family:'. reflect_fonts_style(0).'; }';
	$css .= 'h3{ font-family:'. reflect_fonts_style(0).'; }';
	$css .= 'h4{ font-family:'. reflect_fonts_style(0).'; }';
	$css .= 'h5{ font-family:'. reflect_fonts_style(0).'; }';
	$css .= 'h6{ font-family:'. reflect_fonts_style(0).'; }';
	
	
	/* Font size*/
	$prefix = 'typography_size_';
	$css .= reflect_css_rule('h1', $prefix.'h1', 'font-size');
	$css .= reflect_css_rule('h2', $prefix.'h2', 'font-size');
	$css .= reflect_css_rule('h3', $prefix.'h3', 'font-size');
	$css .= reflect_css_rule('h4', $prefix.'h4', 'font-size');
	$css .= reflect_css_rule('h5', $prefix.'h5', 'font-size');
	$css .= reflect_css_rule('h6', $prefix.'h6', 'font-size');
	$css .= reflect_css_rule('body', $prefix.'body', 'font-size');
	
	
	/*
		Color & Background
	===========================================================*/
	/* Header Top */
	if(apply_filters('reflect_active_header_top', false)){
		$prefix = 'header_top_';
		$class = '.header-top';
	
		$css .= reflect_css_rule($class, $prefix.'text_color', 'color');
		$css .= reflect_css_rule($class.' a', $prefix.'link_color', 'color');
		$css .= reflect_css_rule($class.' a:hover', $prefix.'link_hover_color', 'color');
		
		$css .= reflect_css_rule($class, $prefix.'bg_color', 'background-color');
		$css .= reflect_css_rule($class, $prefix.'bg_image', 'background-image');
		$css .= reflect_css_rule($class, $prefix.'bg_repeat', 'background-repeat');
		$css .= reflect_css_rule($class, $prefix.'bg_attachment', 'background-attachment');
		$css .= reflect_css_rule($class, $prefix.'bg_position', 'background-position');
		$css .= reflect_css_rule($class, $prefix.'bg_size', 'background-size');
	}
	
	
	/* Header Main */
	if(apply_filters('reflect_active_header', false)){
		$prefix = 'header_';
		$class = '.header-main';
		
		
		$text_color_selector = $class.','.$class.' h1,'.$class.' h2,'.$class.' h3,'.$class.' h4,'.$class.' h5,'.$class.' h6';
		$css .= reflect_css_rule($text_color_selector, $prefix.'text_color', 'color');
		$css .= reflect_css_rule($class.' a', $prefix.'link_color', 'color');
		$css .= reflect_css_rule($class.' a:hover', $prefix.'link_hover_color', 'color');
		$css .= reflect_css_rule($class, $prefix.'border_color', 'border-color');
		
		$css .= reflect_css_rule($class, $prefix.'bg_color', 'background-color');
		$css .= reflect_css_rule($class, $prefix.'bg_image', 'background-image');
		$css .= reflect_css_rule($class, $prefix.'bg_repeat', 'background-repeat');
		$css .= reflect_css_rule($class, $prefix.'bg_attachment', 'background-attachment');
		$css .= reflect_css_rule($class, $prefix.'bg_position', 'background-position');
		$css .= reflect_css_rule($class, $prefix.'bg_size', 'background-size');
		
		$css .= reflect_css_rule($class . ' .header_logo', $prefix.'logo_top_margin', 'margin-top');
		$css .= reflect_css_rule($class . ' .header_logo', $prefix.'logo_bottom_margin', 'margin-bottom');
		$css .= reflect_css_rule('.primary_nav', $prefix.'menu_top_margin', 'margin-top');
		$css .= reflect_css_rule('.primary_nav', $prefix.'menu_bottom_margin', 'margin-bottom');
		$css .= reflect_css_rule('.header-main-right', $prefix.'others_top_margin', 'margin-top');
		$css .= reflect_css_rule('.header-main-right', $prefix.'others_bottom_margin', 'margin-bottom');
	}
	
	
	/* Header Bottom */
	if(apply_filters('reflect_active_header', false)){
		$prefix = 'header_bottom_';
		$class = '.header-bottom';
		
		$text_color_selector = $class.','.$class.' h1,'.$class.' h2,'.$class.' h3,'.$class.' h4,'.$class.' h5,'.$class.' h6';
		$css .= reflect_css_rule($text_color_selector, $prefix.'text_color', 'color');
		$css .= reflect_css_rule($class.' a', $prefix.'link_color', 'color');
		$css .= reflect_css_rule($class.' a:hover', $prefix.'link_hover_color', 'color');
		
		$css .= reflect_css_rule($class, $prefix.'bg_color', 'background-color');
		$css .= reflect_css_rule($class, $prefix.'bg_image', 'background-image');
		$css .= reflect_css_rule($class, $prefix.'bg_repeat', 'background-repeat');
		$css .= reflect_css_rule($class, $prefix.'bg_attachment', 'background-attachment');
		$css .= reflect_css_rule($class, $prefix.'bg_position', 'background-position');
		$css .= reflect_css_rule($class, $prefix.'bg_size', 'background-size');
	}
	
	
	/* Footer Top */
	if(apply_filters('reflect_active_footer_top', false)){
		$prefix = 'footer_top_';
		$class = '.footer-top';
		
		$text_color_selector = $class.','.$class.' h1,'.$class.' h2,'.$class.' h3,'.$class.' h4,'.$class.' h5,'.$class.' h6';
		$css .= reflect_css_rule($text_color_selector, $prefix.'text_color', 'color');
		$css .= reflect_css_rule($class.' a', $prefix.'link_color', 'color');
		$css .= reflect_css_rule($class.' a:hover', $prefix.'link_hover_color', 'color');
		$css .= reflect_css_rule($class, $prefix.'border_color', 'border-color');
		
		$css .= reflect_css_rule($class, $prefix.'bg_color', 'background-color');
		$css .= reflect_css_rule($class, $prefix.'bg_image', 'background-image');
		$css .= reflect_css_rule($class, $prefix.'bg_repeat', 'background-repeat');
		$css .= reflect_css_rule($class, $prefix.'bg_attachment', 'background-attachment');
		$css .= reflect_css_rule($class, $prefix.'bg_position', 'background-position');
		$css .= reflect_css_rule($class, $prefix.'bg_size', 'background-size');
	}
	
	
	/* Footer Widgets */
	if(apply_filters('reflect_active_footer', false)){
		$prefix = 'footer_';
		$class = '.footer-widgets';
		
		$text_color_selector = $class.' h1,'.$class.' h2,'.$class.' h3,'.$class.' h4,'.$class.' h5,'.$class.' h6';
		$css .= reflect_css_rule($text_color_selector, $prefix.'title_color', 'color');
		$css .= reflect_css_rule($class, $prefix.'text_color', 'color');
		$css .= reflect_css_rule(
			'.footer-widgets a, .footer-widgets .widget_nav_menu ul li a, .footer-widgets li a, .footer-widgets .widget_meta ul li a, .footer-widgets .widget_recent_comments ul li a, .footer-widgets .widget_recent_comments ul li', 
			$prefix.'link_color', 
			'color'
		);
		$css .= reflect_css_rule(
			'.footer-widgets a:hover, .footer-widgets li a:hover,
.footer-widgets .widget_meta ul li a:hover, 
.footer-widgets .widget_pages ul li a:hover, 
.footer-widgets .widget_nav_menu ul li a:hover, 
.footer-widgets .widget_recent_entries ul li a:hover, 
.footer-widgets .widget_archive ul li a:hover, 
.footer-widgets .widget_categories ul li a:hover, 
.footer-widgets .widget_recent_comments ul li a:hover', 
			$prefix.'link_hover_color', 
			'color'
		);
		$css .= reflect_css_rule(
			'.footer-widgets, .widget_meta ul li, .footer-widgets .widget_pages ul li, .footer-widgets .widget_nav_menu ul li, .footer-widgets .widget_recent_entries ul li, .footer-widgets .widget_archive ul li, .footer-widgets .widget_categories ul li, .footer-widgets .widget_recent_comments ul li, .footer-widgets .widget_meta ul ul.children, .footer-widgets .widget_pages ul ul.children, .footer-widgets .widget_nav_menu ul ul.children, .footer-widgets .widget_recent_entries ul ul.children, .footer-widgets .widget_archive ul ul.children, .footer-widgets .widget_categories ul ul.children, .footer-widgets .widget_recent_comments ul ul.children, .footer-widgets .widget_nav_menu ul ul.sub-menu', 
			$prefix.'inner_border_color', 
			'border-color'
		);
		$css .= reflect_css_rule('.footer-widgets', $prefix.'inner_border_color', 'border-color');
		
		$css .= reflect_css_rule($class, $prefix.'bg_color', 'background-color');
		$css .= reflect_css_rule($class, $prefix.'bg_image', 'background-image');
		$css .= reflect_css_rule($class, $prefix.'bg_repeat', 'background-repeat');
		$css .= reflect_css_rule($class, $prefix.'bg_attachment', 'background-attachment');
		$css .= reflect_css_rule($class, $prefix.'bg_position', 'background-position');
		$css .= reflect_css_rule($class, $prefix.'bg_size', 'background-size');
	}
	
	/* Footer Copyright */
	if(apply_filters('reflect_active_footer_bottom', false)){
		$prefix = 'footer_bottom_';
		$class = '.footer-bottom';
		
		$text_color_selector = $class.','.$class.' h1,'.$class.' h2,'.$class.' h3,'.$class.' h4,'.$class.' h5,'.$class.' h6';
		$css .= reflect_css_rule($class, $prefix.'text_color', 'color');
		$css .= reflect_css_rule($class.' a', $prefix.'link_color', 'color');
		$css .= reflect_css_rule($class.' a:hover', $prefix.'link_hover_color', 'color');
		$css .= reflect_css_rule($class, $prefix.'border_color', 'border-color');
		$css .= reflect_css_rule($class . ' *, .footer-bottom .section-inner', $prefix.'inner_border_color', 'border-color');
		
		$css .= reflect_css_rule($class, $prefix.'bg_color', 'background-color');
		$css .= reflect_css_rule($class, $prefix.'bg_image', 'background-image');
		$css .= reflect_css_rule($class, $prefix.'bg_repeat', 'background-repeat');
		$css .= reflect_css_rule($class, $prefix.'bg_attachment', 'background-attachment');
		$css .= reflect_css_rule($class, $prefix.'bg_position', 'background-position');
		$css .= reflect_css_rule($class, $prefix.'bg_size', 'background-size');
	}
	
	
	/* Content Area */
	$prefix = 'content_area_';
	$class	= '.primary';
		
	$text_color_selector = $class.' h1,'.$class.' h2,'.$class.' h3,'.$class.' h4,'.$class.' h5,'.$class.' h6';
	$css .= reflect_css_rule($class, $prefix.'text_color', 'color');
	$css .= reflect_css_rule($text_color_selector, $prefix.'title_color', 'color');
	$css .= reflect_css_rule($class.' a', $prefix.'link_color', 'color');
	$css .= reflect_css_rule($class.' a:hover', $prefix.'link_hover_color', 'color');
	$css .= reflect_css_rule($class, $prefix.'border_color', 'border-color');
	$css .= reflect_css_rule($class . ' *, .footer-bottom .section-inner', $prefix.'inner_border_color', 'border-color');
		
	$css .= reflect_css_rule($class, $prefix.'bg_color', 'background-color');
	$css .= reflect_css_rule($class, $prefix.'bg_image', 'background-image');
	$css .= reflect_css_rule($class, $prefix.'bg_repeat', 'background-repeat');
	$css .= reflect_css_rule($class, $prefix.'bg_attachment', 'background-attachment');
	$css .= reflect_css_rule($class, $prefix.'bg_position', 'background-position');
	$css .= reflect_css_rule($class, $prefix.'bg_size', 'background-size');
	
	
	/* Navigation Settings
	==========================================*/
	
	
	
	/* Forms & Buttons 
	==========================================*/
	
	/* Forms Fields */
	$prefix = 'forms_field_color_';
	$class	= 'input[type="text"], input[type="email"], input[type="url"], input[type="password"], input[type="search"], input[type="number"], input[type="tel"], input[type="range"], input[type="date"], input[type="month"], input[type="week"], input[type="time"], input[type="datetime"], input[type="datetime-local"], input[type="color"], textarea';
	
	$css .= reflect_css_rule($class, $prefix.'border', 'border-color');
	$css .= reflect_css_rule($class, $prefix.'bg', 'background-color');
	
	$css .= reflect_css_rule('input[type="text"]', $prefix.'placeholder', 'placeholder-color');
	$css .= reflect_css_rule('input[type="email"]', $prefix.'placeholder', 'placeholder-color');
	$css .= reflect_css_rule('input[type="url"]', $prefix.'placeholder', 'placeholder-color');
	$css .= reflect_css_rule('input[type="password"]', $prefix.'placeholder', 'placeholder-color');
	$css .= reflect_css_rule('input[type="search"]', $prefix.'placeholder', 'placeholder-color');
	$css .= reflect_css_rule('input[type="number"]', $prefix.'placeholder', 'placeholder-color');
	$css .= reflect_css_rule('input[type="tel"]', $prefix.'placeholder', 'placeholder-color');
	$css .= reflect_css_rule('input[type="range"]', $prefix.'placeholder', 'placeholder-color');
	$css .= reflect_css_rule('input[type="date"]', $prefix.'placeholder', 'placeholder-color');
	$css .= reflect_css_rule('input[type="month"]', $prefix.'placeholder', 'placeholder-color');
	$css .= reflect_css_rule('input[type="week"]', $prefix.'placeholder', 'placeholder-color');
	$css .= reflect_css_rule('input[type="time"]', $prefix.'placeholder', 'placeholder-color');
	$css .= reflect_css_rule('input[type="datetime"]', $prefix.'placeholder', 'placeholder-color');
	$css .= reflect_css_rule('input[type="datetime-local"]', $prefix.'placeholder', 'placeholder-color');
	$css .= reflect_css_rule('input[type="color"]', $prefix.'placeholder', 'placeholder-color');
	$css .= reflect_css_rule('textarea', $prefix.'placeholder', 'placeholder-color');
	
	
	/* Buttons */
	$prefix = 'forms_button1_';
	$class	= '.ep_button, button, input[type="button"], input[type="reset"], input[type="submit"], .more-link';
	$class_hover	= '.ep_button:hover, button:hover, input[type="button"]:hover, input[type="reset"]:hover, input[type="submit"]:hover, .more-link:hover';
	
	$css .= reflect_css_rule($class, $prefix.'border', 'border-color');
	$css .= reflect_css_rule($class, $prefix.'bg', 'background-color');
	$css .= reflect_css_rule($class, $prefix.'text', 'color');
	
	$css .= reflect_css_rule($class_hover, $prefix.'border_hover', 'border-color');
	$css .= reflect_css_rule($class_hover, $prefix.'bg_hover', 'background-color');
	$css .= reflect_css_rule($class_hover, $prefix.'text_hover', 'color');
	
	
	
	return $css;
}