<?php
if(!function_exists('reflect_customize_register')):
function reflect_customize_register( $wp_customize ) {
	
	/*========================================================
		START::: Contact Info
	=========================================================*/
	$wp_customize->add_panel( 'contact_panel', array(
		'title'			=> __('* Contact Info', 'reflect'),
		'description'	=> '',
		'priority'   => 30,
	));
	
	/*
		Contact Info --> Contact Text
	===============================================*/
	if(apply_filters('reflect_active_contact_text', false)){
		$prefix = 'contact_info_';
		$section = 'contact_info_section_';
		
		$wp_customize->add_section( $section , array(
			'title'      => __( 'Contact Text', 'reflect' ),
			'priority'   => 30,
			'panel'		=> 'contact_panel',
		));
		$uid = $prefix.'enable';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'sanitize_key', ));
		$wp_customize->add_control( $uid, array(
			'label'      => __('Enable Contact Info', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'type'       => 'checkbox',
			'description' => '',
		));
		$uid = $prefix.'text';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'wp_kses_post', ));
		$wp_customize->add_control( $uid, array(
			'label'      => __('Contact Info', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'type'       => 'textarea',
			'description' => 'Add your Email or Mobile Number here. In order to make the number a tap-to-call for the mobile site, simply add this piece of code to the field:',
		));
		$uid = $prefix.'info1';
		$wp_customize->add_setting($uid, array( 'default' => '', 'sanitize_callback' => 'sanitize_text_field', ));
		$wp_customize->add_control(new reflect_Customize_Control_info( $wp_customize, $uid, array(
			'label'      => __( 'Examples:', 'reflect' ),
			'description' => '<span style="font-size:18px;" >Call Us: <a href="tel:1234567890" style="color:#000000;">1-2345-678-90</a></span>',
			'section'    => $section,
			'settings'   => $uid,
		)));
	}
	
	/*
		Contact Info --> Phone Number
	===============================================*/
	if(apply_filters('reflect_active_phone', false)){
		$prefix = 'contact_phone_';
		$section = 'contact_phone_section_';
		
		$wp_customize->add_section( $section , array(
			'title'      => __( 'Phone Number', 'reflect' ),
			'priority'   => 30,
			'panel'		=> 'contact_panel',
		));
		$uid = $prefix.'enable';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'sanitize_key', ));
		$wp_customize->add_control( $uid, array(
			'label'      => __('Enable Phone Number', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'type'       => 'checkbox',
			'description' => '',
		));
		$uid = $prefix.'text';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'sanitize_text_field', ));
		$wp_customize->add_control( $uid, array(
			'label'      => __('Phone Number', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'type'       => 'text',
			'description' => 'Example: (123)-456-7898',
		));
		$uid = $prefix.'link';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'sanitize_text_field', ));
		$wp_customize->add_control( $uid, array(
			'label'      => __('Phone Number for Link', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'type'       => 'text',
			'description' => 'Example: 123456780',
		));
		$uid = $prefix.'des';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'wp_kses_post', ));
		$wp_customize->add_control( $uid, array(
			'label'      => __('Description', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'description' => '',
			'type'       => 'text',
		));
		$uid = $prefix.'icon';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'esc_url_raw', ));
		$wp_customize->add_control( new WP_Customize_Image_Control($wp_customize, $uid, array(
			'label'      => __('Icon', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'description' => '',
		)));
	}
	
	/*
		Contact Info --> Email
	===============================================*/
	if(apply_filters('reflect_active_email', false)){
		$prefix = 'contact_email_';
		$section = 'contact_email_section_';
		
		$wp_customize->add_section( $section , array(
			'title'      => __( 'Email Address', 'reflect' ),
			'priority'   => 30,
			'panel'		=> 'contact_panel',
		));
		$uid = $prefix.'enable';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'sanitize_key', ));
		$wp_customize->add_control( $uid, array(
			'label'      => __('Enable Email Address', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'type'       => 'checkbox',
			'description' => '',
		));
		$uid = $prefix.'text';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'sanitize_text_field', ));
		$wp_customize->add_control( $uid, array(
			'label'      => __('Email Address', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'type'       => 'text',
			'description' => '',
		));
		$uid = $prefix.'des';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'wp_kses_post', ));
		$wp_customize->add_control( $uid, array(
			'label'      => __('Description', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'description' => '',
			'type'       => 'text',
		));
		$uid = $prefix.'icon';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'esc_url_raw', ));
		$wp_customize->add_control( new WP_Customize_Image_Control($wp_customize, $uid, array(
			'label'      => __('Icon', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'description' => '',
		)));
	}
	
	/*
		Contact Info --> Opening Hours
	===============================================*/
	if(apply_filters('reflect_active_hours', false)){
		$prefix = 'contact_hours_';
		$section = 'contact_hours_section_';
		
		$wp_customize->add_section( $section , array(
			'title'      => __( 'Opening Hours', 'reflect' ),
			'priority'   => 30,
			'panel'		=> 'contact_panel',
		));
		$uid = $prefix.'enable';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'sanitize_key', ));
		$wp_customize->add_control( $uid, array(
			'label'      => __('Enable Opening Hours', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'type'       => 'checkbox',
			'description' => '',
		));
		$uid = $prefix.'text';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'wp_kses_post', ));
		$wp_customize->add_control( $uid, array(
			'label'      => __('Opening Hours', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'type'       => 'text',
			'description' => '',
		));
		$uid = $prefix.'des';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'wp_kses_post', ));
		$wp_customize->add_control( $uid, array(
			'label'      => __('Description', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'description' => '',
			'type'       => 'text',
		));
		$uid = $prefix.'icon';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'esc_url_raw', ));
		$wp_customize->add_control( new WP_Customize_Image_Control($wp_customize, $uid, array(
			'label'      => __('Icon', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'description' => '',
		)));
	}
	
	/*
		Contact Info --> Address
	===============================================*/
	if(apply_filters('reflect_active_address', false)){
		$prefix = 'contact_address_';
		$section = 'contact_address_section_';
		
		$wp_customize->add_section( $section , array(
			'title'      => __( 'Address', 'reflect' ),
			'priority'   => 30,
			'panel'		=> 'contact_panel',
		));
		$uid = $prefix.'enable';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'sanitize_key', ));
		$wp_customize->add_control( $uid, array(
			'label'      => __('Enable Address', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'type'       => 'checkbox',
			'description' => '',
		));
		$uid = $prefix.'line1';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'wp_kses_post', ));
		$wp_customize->add_control( $uid, array(
			'label'      => __('Address Line 1', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'type'       => 'text',
			'description' => '',
		));
		$uid = $prefix.'line2';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'wp_kses_post', ));
		$wp_customize->add_control( $uid, array(
			'label'      => __('Address Line 2', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'type'       => 'text',
			'description' => '',
		));
		$uid = $prefix.'icon';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'esc_url_raw', ));
		$wp_customize->add_control( new WP_Customize_Image_Control($wp_customize, $uid, array(
			'label'      => __('Icon', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'description' => '',
		)));
	}
	/*========================================================
		END ::: Contact Info
	=========================================================*/
	
	
	
	/*========================================================
		START::: Social Icons
	=========================================================*/
	if(apply_filters('reflect_active_social_icons', false)){
		$prefix = 'social_icons_';
		$section = 'social_icons_section_';
		
		$wp_customize->add_section( $section , array(
			'title'			=> __('* Social Bookmarking', 'reflect'),
			'priority'   => 30,
		));
		$uid = $prefix.'enable';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'sanitize_key', ));
		$wp_customize->add_control( $uid, array(
			'label'      => __('Enable Social Icons', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'type'       => 'checkbox',
			'description' => '',
		));
		$uid = $prefix.'heading1';
		$wp_customize->add_setting($uid, array( 'default' => '', 'sanitize_callback' => 'sanitize_text_field', ));
		$wp_customize->add_control(new reflect_Customize_Control_heading( $wp_customize, $uid, array(
			'label'      => __( 'Social Profile #1', 'reflect' ),
			'section'    => $section,
			'settings'   => $uid,
		)));
		
		$uid = $prefix.'title_1';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'sanitize_text_field', ));
		$wp_customize->add_control( $uid, array(
			'label'      => __('Title', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'type'       => 'text',
			'description' => '',
		));
		$uid = $prefix.'link_1';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'esc_url_raw', ));
		$wp_customize->add_control( $uid, array(
			'label'      => __('Link', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'type'       => 'text',
			'description' => '',
		));
		$uid = $prefix.'image_1';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'esc_url_raw', ));
		$wp_customize->add_control( new WP_Customize_Image_Control($wp_customize, $uid, array(
			'label'      => __('Icon', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'description' => '',
		)));
		
		
		$uid = $prefix.'heading2';
		$wp_customize->add_setting($uid, array( 'default' => '', 'sanitize_callback' => 'sanitize_text_field', ));
		$wp_customize->add_control(new reflect_Customize_Control_heading( $wp_customize, $uid, array(
			'label'      => __( 'Social Profile #2', 'reflect' ),
			'section'    => $section,
			'settings'   => $uid,
		)));
		
		$uid = $prefix.'title_2';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'sanitize_text_field', ));
		$wp_customize->add_control( $uid, array(
			'label'      => __('Title', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'type'       => 'text',
			'description' => '',
		));
		$uid = $prefix.'link_2';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'esc_url_raw', ));
		$wp_customize->add_control( $uid, array(
			'label'      => __('Link', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'type'       => 'text',
			'description' => '',
		));
		$uid = $prefix.'image_2';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'esc_url_raw', ));
		$wp_customize->add_control( new WP_Customize_Image_Control($wp_customize, $uid, array(
			'label'      => __('Icon', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'description' => '',
		)));
		
		
		$uid = $prefix.'heading3';
		$wp_customize->add_setting($uid, array( 'default' => '', 'sanitize_callback' => 'sanitize_text_field', ));
		$wp_customize->add_control(new reflect_Customize_Control_heading( $wp_customize, $uid, array(
			'label'      => __( 'Social Profile #3', 'reflect' ),
			'section'    => $section,
			'settings'   => $uid,
		)));
		
		$uid = $prefix.'title_3';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'sanitize_text_field', ));
		$wp_customize->add_control( $uid, array(
			'label'      => __('Title', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'type'       => 'text',
			'description' => '',
		));
		$uid = $prefix.'link_3';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'esc_url_raw', ));
		$wp_customize->add_control( $uid, array(
			'label'      => __('Link', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'type'       => 'text',
			'description' => '',
		));
		$uid = $prefix.'image_3';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'esc_url_raw', ));
		$wp_customize->add_control( new WP_Customize_Image_Control($wp_customize, $uid, array(
			'label'      => __('Icon', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'description' => '',
		)));
		
		
		$uid = $prefix.'heading4';
		$wp_customize->add_setting($uid, array( 'default' => '', 'sanitize_callback' => 'sanitize_text_field', ));
		$wp_customize->add_control(new reflect_Customize_Control_heading( $wp_customize, $uid, array(
			'label'      => __( 'Social Profile #4', 'reflect' ),
			'section'    => $section,
			'settings'   => $uid,
		)));
		
		$uid = $prefix.'title_4';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'sanitize_text_field', ));
		$wp_customize->add_control( $uid, array(
			'label'      => __('Title', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'type'       => 'text',
			'description' => '',
		));
		$uid = $prefix.'link_4';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'esc_url_raw', ));
		$wp_customize->add_control( $uid, array(
			'label'      => __('Link', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'type'       => 'text',
			'description' => '',
		));
		$uid = $prefix.'image_4';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'esc_url_raw', ));
		$wp_customize->add_control( new WP_Customize_Image_Control($wp_customize, $uid, array(
			'label'      => __('Icon', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'description' => '',
		)));
		
		$uid = $prefix.'heading5';
		$wp_customize->add_setting($uid, array( 'default' => '', 'sanitize_callback' => 'sanitize_text_field', ));
		$wp_customize->add_control(new reflect_Customize_Control_heading( $wp_customize, $uid, array(
			'label'      => __( 'Social Profile #5', 'reflect' ),
			'section'    => $section,
			'settings'   => $uid,
		)));
		
		$uid = $prefix.'title_5';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'sanitize_text_field', ));
		$wp_customize->add_control( $uid, array(
			'label'      => __('Title', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'type'       => 'text',
			'description' => '',
		));
		$uid = $prefix.'link_5';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'esc_url_raw', ));
		$wp_customize->add_control( $uid, array(
			'label'      => __('Link', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'type'       => 'text',
			'description' => '',
		));
		$uid = $prefix.'image_5';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'esc_url_raw', ));
		$wp_customize->add_control( new WP_Customize_Image_Control($wp_customize, $uid, array(
			'label'      => __('Icon', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'description' => '',
		)));
		
		$uid = $prefix.'heading6';
		$wp_customize->add_setting($uid, array( 'default' => '', 'sanitize_callback' => 'sanitize_text_field', ));
		$wp_customize->add_control(new reflect_Customize_Control_heading( $wp_customize, $uid, array(
			'label'      => __( 'Social Profile #6', 'reflect' ),
			'section'    => $section,
			'settings'   => $uid,
		)));
		
		$uid = $prefix.'title_6';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'sanitize_text_field', ));
		$wp_customize->add_control( $uid, array(
			'label'      => __('Title', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'type'       => 'text',
			'description' => '',
		));
		$uid = $prefix.'link_6';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'esc_url_raw', ));
		$wp_customize->add_control( $uid, array(
			'label'      => __('Link', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'type'       => 'text',
			'description' => '',
		));
		$uid = $prefix.'image_6';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'esc_url_raw', ));
		$wp_customize->add_control( new WP_Customize_Image_Control($wp_customize, $uid, array(
			'label'      => __('Icon', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'description' => '',
		)));
		
		$uid = $prefix.'heading7';
		$wp_customize->add_setting($uid, array( 'default' => '', 'sanitize_callback' => 'sanitize_text_field', ));
		$wp_customize->add_control(new reflect_Customize_Control_heading( $wp_customize, $uid, array(
			'label'      => __( 'Social Profile #7', 'reflect' ),
			'section'    => $section,
			'settings'   => $uid,
		)));
		
		$uid = $prefix.'title_7';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'sanitize_text_field', ));
		$wp_customize->add_control( $uid, array(
			'label'      => __('Title', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'type'       => 'text',
			'description' => '',
		));
		$uid = $prefix.'link_7';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'esc_url_raw', ));
		$wp_customize->add_control( $uid, array(
			'label'      => __('Link', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'type'       => 'text',
			'description' => '',
		));
		$uid = $prefix.'image_17';
		$wp_customize->add_setting($uid, array( 'default' => reflect_customize_std($uid), 'sanitize_callback' => 'esc_url_raw', ));
		$wp_customize->add_control( new WP_Customize_Image_Control($wp_customize, $uid, array(
			'label'      => __('Icon', 'reflect'),
			'section'    => $section,
			'settings'   => $uid,
			'description' => '',
		)));
	}
	/*========================================================
		END::: Social Icons
	=========================================================*/
	
	
	
}
endif;
add_action( 'customize_register', 'reflect_customize_register' );



function reflect_Customize_Control_heading($wp_customize){
	if( class_exists( 'WP_Customize_Control' ) ):
		class reflect_Customize_Control_heading extends WP_Customize_Control {
			public $label;
			public $description;
			public $type = 'reflect-heading';
			
			public function render_content(){
				?>
				<div class="reflect_Customize_Control_heading" style="background: #fff; box-sizing: border-box; padding: 15px 20px; margin-left: -20px; margin-right: -20px; margin-top: 10px;">
					<?php
					if($this->label){ 
						echo '<h4 style="margin:0; font-size: 17px;">';
							echo esc_attr($this->label);
						echo '</h4>'; 
					}
					if($this->description){ echo '<p>'.esc_html($this->description).'</p>'; }
					?>
				</div>
				<?php
			}
		}
	endif;
}
add_action( 'customize_register', 'reflect_Customize_Control_heading', 1 );



function reflect_Customize_Control_info($wp_customize){
	if( class_exists( 'WP_Customize_Control' ) ):
		class reflect_Customize_Control_info extends WP_Customize_Control {
			public $label;
			public $description;
			public $type = 'reflect-info';
			
			public function render_content(){
				?>
				<div>
					<?php
					if($this->label){ 
						echo '<h4 style="margin:0; font-size: 17px;">';
							echo esc_attr($this->label);
						echo '</h4>'; 
					}
					if($this->description){ echo esc_html($this->description); }
					?>
				</div>
				<?php
			}
		}
	endif;
}
add_action( 'customize_register', 'reflect_Customize_Control_info', 1 );